Index: pacemaker/pengine/test10/594.exp
===================================================================
--- pacemaker.orig/pengine/test10/594.exp
+++ pacemaker/pengine/test10/594.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="16" operation="monitor" operation_key="DcIPaddr_monitor_5000" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="DcIPaddr" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  ip="127.0.0.10"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_timeout="20000"  ip="127.0.0.10"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="15" operation="start" operation_key="DcIPaddr_start_0" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="DcIPaddr" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="127.0.0.10"/>
+        <attributes CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_timeout="20000"  ip="127.0.0.10"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -35,7 +35,7 @@
     <action_set>
       <rsc_op id="14" operation="stop" operation_key="DcIPaddr_stop_0" on_node="hadev2" on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3">
         <primitive id="DcIPaddr" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="127.0.0.10"/>
+        <attributes CRM_meta_on_node="hadev2" CRM_meta_on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3" CRM_meta_timeout="20000"  ip="127.0.0.10"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -48,7 +48,7 @@
     <action_set>
       <rsc_op id="9" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="DcIPaddr" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  ip="127.0.0.10"/>
+        <attributes CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  ip="127.0.0.10"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -57,7 +57,7 @@
     <action_set>
       <rsc_op id="12" operation="monitor" operation_key="rsc_hadev3_monitor_0" on_node="hadev2" on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3">
         <primitive id="rsc_hadev3" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  ip="127.0.0.21"/>
+        <attributes CRM_meta_on_node="hadev2" CRM_meta_on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  ip="127.0.0.21"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -66,7 +66,7 @@
     <action_set>
       <rsc_op id="21" operation="monitor" operation_key="rsc_hadev2_monitor_5000" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="rsc_hadev2" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  ip="127.0.0.22"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_timeout="20000"  ip="127.0.0.22"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -79,7 +79,7 @@
     <action_set>
       <rsc_op id="20" operation="start" operation_key="rsc_hadev2_start_0" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="rsc_hadev2" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="127.0.0.22"/>
+        <attributes CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_timeout="20000"  ip="127.0.0.22"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -98,7 +98,7 @@
     <action_set>
       <rsc_op id="19" operation="stop" operation_key="rsc_hadev2_stop_0" on_node="hadev2" on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3">
         <primitive id="rsc_hadev2" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="127.0.0.22"/>
+        <attributes CRM_meta_on_node="hadev2" CRM_meta_on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3" CRM_meta_timeout="20000"  ip="127.0.0.22"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -111,7 +111,7 @@
     <action_set>
       <rsc_op id="10" operation="monitor" operation_key="rsc_hadev2_monitor_0" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="rsc_hadev2" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  ip="127.0.0.22"/>
+        <attributes CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  ip="127.0.0.22"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -120,7 +120,7 @@
     <action_set>
       <rsc_op id="24" operation="stop" operation_key="child_DoFencing:0_stop_0" on_node="hadev2" on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3">
         <primitive id="child_DoFencing:0" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="hadev2" CRM_meta_on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -136,7 +136,7 @@
     <action_set>
       <rsc_op id="11" operation="monitor" operation_key="child_DoFencing:0_monitor_0" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="child_DoFencing:0" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -145,7 +145,7 @@
     <action_set>
       <rsc_op id="27" operation="stop" operation_key="child_DoFencing:2_stop_0" on_node="hadev1" on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="hadev1" CRM_meta_on_node_uuid="6125a0df-456a-4395-829a-418e9a380d36" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -158,7 +158,7 @@
     <action_set>
       <rsc_op id="13" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="hadev2" on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="hadev2" CRM_meta_on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  hostlist="hadev3 hadev2 hadev1 "/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -203,7 +203,7 @@
   <synapse id="16">
     <action_set>
       <crm_event id="33" operation="do_shutdown" operation_key="do_shutdown-hadev2" on_node="hadev2" on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="hadev2" CRM_meta_on_node_uuid="190b75b6-5585-42d9-8cde-eb6041843ae3" CRM_meta_op_no_wait="true" />
         <downed>
           <node id="190b75b6-5585-42d9-8cde-eb6041843ae3"/>
         </downed>
Index: pacemaker/pengine/test10/6-migrate-group.exp
===================================================================
--- pacemaker.orig/pengine/test10/6-migrate-group.exp
+++ pacemaker/pengine/test10/6-migrate-group.exp
@@ -65,7 +65,7 @@
     <action_set>
       <rsc_op id="9" operation="migrate_from" operation_key="A_migrate_from_0" on_node="18node2" on_node_uuid="2">
         <primitive id="A" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -78,7 +78,7 @@
     <action_set>
       <rsc_op id="8" operation="migrate_to" operation_key="A_migrate_to_0" on_node="18node1" on_node_uuid="1">
         <primitive id="A" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -87,7 +87,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="A_monitor_60000" on_node="18node2" on_node_uuid="2">
         <primitive id="A" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -118,7 +118,7 @@
     <action_set>
       <rsc_op id="5" operation="stop" operation_key="A_stop_0" on_node="18node1" on_node_uuid="1">
         <primitive id="A" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -137,7 +137,7 @@
     <action_set>
       <rsc_op id="14" operation="migrate_from" operation_key="B_migrate_from_0" on_node="18node2" on_node_uuid="2">
         <primitive id="B" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -150,7 +150,7 @@
     <action_set>
       <rsc_op id="13" operation="migrate_to" operation_key="B_migrate_to_0" on_node="18node1" on_node_uuid="1">
         <primitive id="B" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -163,7 +163,7 @@
     <action_set>
       <rsc_op id="12" operation="monitor" operation_key="B_monitor_60000" on_node="18node2" on_node_uuid="2">
         <primitive id="B" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -197,7 +197,7 @@
     <action_set>
       <rsc_op id="10" operation="stop" operation_key="B_stop_0" on_node="18node1" on_node_uuid="1">
         <primitive id="B" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -216,7 +216,7 @@
     <action_set>
       <rsc_op id="19" operation="migrate_from" operation_key="C_migrate_from_0" on_node="18node2" on_node_uuid="2">
         <primitive id="C" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -229,7 +229,7 @@
     <action_set>
       <rsc_op id="18" operation="migrate_to" operation_key="C_migrate_to_0" on_node="18node1" on_node_uuid="1">
         <primitive id="C" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_migrate_source="18node1" CRM_meta_migrate_target="18node2" CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -242,7 +242,7 @@
     <action_set>
       <rsc_op id="17" operation="monitor" operation_key="C_monitor_60000" on_node="18node2" on_node_uuid="2">
         <primitive id="C" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -276,7 +276,7 @@
     <action_set>
       <rsc_op id="15" operation="stop" operation_key="C_stop_0" on_node="18node1" on_node_uuid="1">
         <primitive id="C" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
